climatedemo/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
# from histo.views import main
from django.views.generic import TemplateView

from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    # path('climap/', include('climap.urls')),
    path('stats/', include('stats.urls')),
    path('proj/', include('proj.urls')),
    path('favicon.ico',
        RedirectView.as_view( # the redirecting function
            url=staticfiles_storage.url('img/favicon.ico'), # converts the static directory + our favicon into a URL
        ),
        name="favicon" # name of our view
    ),
    path('', TemplateView.as_view(template_name='proj/main.html'), name='main'),
]

# if not settings.DOCKER:
#     urlpatterns.insert(0, path('climap/', include('climap.urls')))

proj/urls.py
from django.urls import path, register_converter
from django.views.generic import TemplateView
from . import views
from .export import image
from .netcdf import write_netcdf
from .maintenance import print_zd, del_zd, del_mrd, print_sp, del_sp, display_station_proj, print_param, del_param, listings

app_name = 'proj'

class Extension:
    regex = '[a-z]{2,3}'

    def to_python(self, value):
        return str(value)

    to_url = to_python

register_converter(Extension, 'xxx')

urlpatterns = [
    # static
    path('about', views.about, name='about'),
    path('help', views.help, name='help'),
    path('formula', views.formula, name='formula'),
    path('download', views.download, name='download'),
    path('faq', TemplateView.as_view(template_name='proj/faq.html'), name='faq'),

    path ('downparam/<pr>_<scen>_<zone>.csv', views.param_download, name='param_download'),
    path('downmetric/<met>_<scen>_<model>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<met>_<scen>.csv', views.metric_download, name='metric_download'),
    path('downmetric/<metric>_<scen>_<model>.nc', write_netcdf, name='netcdf'),
    path('downzone/<met>_<scen>_<zone>.csv', views.zone_metric_download, name='zone_download'),

    # json / export
    path('<update>.json', views.jsoner, name='jsoner'),
    path('<period>.csv', views.csv_export, name='csv'),
    path('<period>.xls', views.xls_export, name='xls'),
    path('export.<xxx:extension>', image, name='plt'),

    # language toggle
    path('lang/<l>', views.lang, name='lang'),

    # main page
    path('simple', views.simple, name='simple'),
    path('', views.index, name='index'),

    # admin
    path('listings', listings, name='listings'),
    path('mod_zd', print_zd, name='print_zd'),
    path('mod_param', print_param, name='print_param'),
    path('mod_sp', print_sp, name='print_sp'),
    path('stations', display_station_proj, name='display_station'),
    path('del_zd/<mid>/<modname>/<scen>', del_zd, name='del_zd_scen'),
    path('del_zd/<mid>/<modname>', del_zd, name='del_zd'),
    path('del_param/<pid>/<modname>/<scen>', del_param, name='del_param_scen'),
    path('del_param/<pid>/<modname>', del_param, name='del_param'),
    path('del_mrd/<mid>/<modname>/<scen>', del_mrd, name='del_mrd_scen'),
    path('del_mrd/<mid>/<modname>', del_mrd, name='del_mrd'),
    path('del_sp/<modname>/<pid>/<sid>/<scen>', del_sp, name='del_sp_scen'),
    path('del_sp/<modname>/<pid>/<sid>/', del_sp, name='del_sp'),
    ]

stats/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required
from django.contrib.auth.views import LoginView
from django.views.generic import TemplateView

from . import views
app_name = 'stats'

urlpatterns = [
    path('login', LoginView.as_view(), name='login'),
    path('doc', TemplateView.as_view(template_name='stats/doc.html'), name='doc'),
    path('metric/<ip>', views.proj_metric, name='metric_by_ip'),
    path('metric', views.proj_metric, name='metric'),
    path('metriccsv', views.proj_metric_csv, name='metric_csv'),
    path('comments', login_required(views.CommentListView.as_view()), name='comments'),
    path('commentwrite', views.CommentCreate.as_view(), name='commentwrite'),
    path('commentdel/<int:pk>', login_required(views.CommentDelete.as_view()), name='commentdel'),
    path('', views.index, name='index'),
]

stats/models.py
from django.db import models

# Create your models here.

# SITE METRICS

class Metric(models.Model):
    """Abstract metric class."""
    class Meta:
        abstract = True
    date = models.DateTimeField(auto_now_add=True)
    ip = models.GenericIPAddressField(null=True)
    nav = models.CharField(max_length=100)


class ProjMetric(Metric):
    url = models.CharField(max_length=400)
    logged = models.BooleanField()

    def url_as_list(self):
        return ', '.join(self.url.split('&'))

class HistoMetric(Metric):
    station_id = models.IntegerField(null=True)
    logged = models.BooleanField()

# COMMENTS

class Comment(models.Model):
    name = models.CharField(max_length=100, default='anonymous')
    mail = models.EmailField(max_length=50, blank=True, help_text='not mandatory')
    comment = models.TextField()
    date = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return '{} comment ({})'.format(self.name, self.date.strftime('%d/%m/%y'))

proj/views.py
import json
import pandas as pd
import io
import base64

from django.http import JsonResponse, HttpResponse, HttpResponseRedirect, HttpRequest
from django.shortcuts import render, reverse
from django.core.serializers import serialize
from django.utils.translation import LANGUAGE_SESSION_KEY, get_language, gettext as _

from stats.decorators import count_proj_request
from . import models as pm
from .cst import *
from .reqscrapper import RequestScrapper
# HYDRO TEST
# from .hydro import image2base64


def image2base64(image):
    """PIL base64 rendering"""
    buf = io.BytesIO()
    image.save(buf, format='PNG', quality=100)
    code = base64.b64encode(buf.getvalue())
    return code.decode('utf-8')


# STATIC PAGES
def help(request):
    context = {
        'refyrs': DEFAULT_REFYRS
    }
    l = get_language()
    file = 'help_fr.html' if l and l.startswith('fr') else 'help.html'
    return render(request, 'proj/' + file, context)


def formula(request):
    l = get_language()
    file = 'formula_fr.html' if l and l.startswith('fr') else 'formula.html'
    return render(request, 'proj/' + file,
                  {'vars': ', '.join(['<b>{}</b> ({})'.format(v.shortname, v.locale_name)
                                      for v in pm.Parameter.objects.all()]),
                   'scenarios': pm.Scenario.objects.all(),
                   'params': pm.Parameter.objects.all(),
                   'zones': [pm.Zone.objects.get(name=settings.MAIN_ZONE)] + list(pm.Zone.objects.exclude(name=settings.MAIN_ZONE)),
                   })


def about(request):
    context = {
        'catmetric': pm.MetricCategory.objects.order_by('-name'),
        'models': pm.ClimateModel.objects.order_by('name'),
        'metrics': pm.Metric.objects.order_by('category', 'name'),
        'scenario': pm.Scenario.objects.order_by('name'),
    }
    return render(request, 'proj/about.html', context)


def faq(request):
    return render(request, 'proj/faq.html')

def download(request):
    context = {
        'scenarios': pm.Scenario.objects.all(),
        'params': pm.Parameter.objects.all(),
        'zones': [pm.Zone.objects.get(name=settings.MAIN_ZONE)] + list(pm.Zone.objects.exclude(name=settings.MAIN_ZONE)),
        'metrics': pm.Metric.objects.all(),
        'models': pm.ClimateModel.objects.order_by('name'),
    }
    return render(request, 'proj/download.html', context)


# LANG TOGGLE
def lang(request, l):
    request.session[LANGUAGE_SESSION_KEY] = l
    return HttpResponseRedirect(request.GET.get('next', reverse('proj:index')))

# MAIN PAGE
def index(request, simple=False):
    if 'lang' in request.GET:
        request.session[LANGUAGE_SESSION_KEY] = request.GET['lang']
        # reload the view
        return index(HttpRequest(), simple=simple)

    regions = pm.Zone.objects.exclude(name=settings.MAIN_ZONE)
    default_metric = pm.Metric.objects.get(shortname=settings.DEFAULT_METRIC).id
    graph_colors = {s.name: {'color': s.color} for s in pm.Scenario.objects.all()}
    graph_colors['ref'] = {'color': 'black'}
    graph_colors[_('model average')] = {'color': 'red', 'strokeWidth': 4, 'strokeBorderWidth': 3}
    graph_colors.update({s.name: {'id': s.id, 'color': s.color, 'strokePattern': DYGRAPH_STROKE.get(s.style, [])}
                         for s in pm.ClimateModel.objects.all()})
    places = pm.Place.objects.all()
    stations = pm.Station.objects.all()#.annotate(projs=Count('stationproj')).filter(projs__gt=0)

    # transform (xmin, xmax, ymin, ymax) into (xmin, ymin, xmax, ymax)
    view = settings.RASTER_BOX.split(',')
    view[1], view[2] = view[2], view[1]

    context = {
        'main_zone': settings.MAIN_ZONE,
        'stations': serialize('geojson', stations),
        'allstations': json.dumps(list(stations.values_list('name', flat=True))),
        'scenarii': pm.Scenario.objects.all(),
        'default_scenario': pm.Scenario.objects.get(name=request.GET.get('scen', DEFAULT_SCENARIO)),
        'regions': serialize('geojson', regions),
        'catmetric': pm.MetricCategory.objects.order_by('-name'),
        'default_metric': pm.Metric.objects.get(id=request.GET.get('metric', default_metric)),
        'allmetrics' : serialize('json', pm.Metric.objects.all()),
        'years': request.GET.get('yrs', DEFAULT_YRS),
        'default_refyrs': request.GET.get('refyrs', DEFAULT_REFYRS),
        'compare': request.GET.get('compare', 'scenarii'),
        'models': pm.ClimateModel.objects.all(),
        'graph_color': json.dumps(graph_colors),
        'places': serialize('geojson', places.filter(show=True)),
        'allplaces': serialize('geojson', places),
        'allplaces_list': json.dumps(list(places.values_list('name', flat=True))),
        'custom_cmap': pm.ColorMap.objects.filter(custom=True).order_by('name'),
        'view': ','.join(view),
    }
    if 'metric' in request.GET and 'yrs' in request.GET:
        context['args'] = '?' + '&'.join(['{}={}'.format(k,v) for (k, v) in request.GET.items()])
    if 'station' in request.GET:
        context['station'] = request.GET['station']

    # TODO : sync with classic
    template = 'proj/newsimple.html' if simple else 'proj/index.html'
    return render(request, template, context)


def simple(request):
    return index(request, simple=True)

def metric_download(request, met, scen, model=None):
    dflist = []
    for z in pm.Zone.objects.all():
        zd = pm.ZonedData.objects.get(zone=z, metric__shortname=met)
        df = zd.get_data(scen)
        if model :
            df = df[model]
        else:
            df = df.mean(axis=1)
        df.name = z.name
        dflist.append(df)
    total = pd.concat(dflist, axis=1)
    r = HttpResponse(content_type='text/csv')
    total.to_csv(r)
    return r

def zone_metric_download(request, met, scen, zone):
    zd = pm.ZonedData.objects.get(zone__name=zone, metric__shortname=met)
    df = zd.get_data(scen)
    r = HttpResponse(content_type='text/csv')
    df.to_csv(r)
    return r

def param_download(request, pr, scen, zone):
    drd = pm.DailyRegionData.objects.get(param__shortname=pr, zone__name=zone)
    df = drd.read_data(scen).round(2)
    r = HttpResponse(content_type='text/csv')
    df.to_csv(r)
    return r

def netcdf_download(request, metricid, modelid, scen):
    qset = pm.MonthlyRasterData.objects.filter(model__id=modelid, scenario__name=scen, metric__id=metricid)
    for mrd in qset:
        data = mrd.raster.bands[0].data()

benchmark = False
if benchmark:
    import time

@count_proj_request
def jsoner(request, update):
    """Main data view.

    update : string, contains one or more of
        'm' (map),
        's' (season, aka month),
        'y' (year).
    """

    if benchmark:
        start = time.time()

    rs = RequestScrapper(request)
    jres = {
        'zone': rs.real_zone,
    }

    if benchmark:
        now = time.time()
        print('rs : {}'.format(now-start))
        start = now

    if rs.metric:
        jres['metric'] = rs.metric.to_dict()
    else:
        jres['metric'] = {
            'name': rs.formula,
            'formula': rs.formula,
            'unit': '',
            'monthly': True,
        }
    if rs.postcalc == 'data':
        jres['metric']['plus'] = ''
    else:
        jres['metric']['plus'] = '+'
        if rs.postcalc == 'relative':
            jres['metric']['unit'] = '%'

    jres['metric']['raster'] = rs.has_raster()

    if benchmark:
        now = time.time()
        print('meta : {}'.format(now - start))
        start = now

    if 'm' in update:
        if rs.showraster or (rs.metric and rs.metric.raster_only):
            b, meta, scale = rs.get_raster()
            # meta = upperleftx | upperlefty | width | height | scalex | scaley | skewx | skewy | srid | numbands
            jres['raster'] = {
                'image': 'data:image/png;base64,' + image2base64(b),
                'extent': [round(meta[0], 2), round(meta[1] + meta[3] * meta[5], 2),
                           round(meta[0] + meta[2] * meta[4], 2), round(meta[1], 2)],
                'xres': round(meta[4],2),
                'yres': round(meta[5],2),
                'scale': scale,
            }
        else:
            rs.fill_regions_df()
            df, scale = rs.map_df()
            if df.empty:
                jres['map'] = False
            else:
                jres['map'] = {
                    'values': df.to_dict(orient='index'),
                    'scale': scale,
                    'title': rs.title['map'],
                }

    if benchmark:
        now = time.time()
        print('map : {}'.format(now - start))
        start = now


    if 's' in update or 'y' in update:
        rs.fill_loc_df()
        if 's' in update and rs.monthly:
            jres['month'] = rs.df_to_dygraphs(rs.month_df())
            if jres['month']:
                jres['month']['meta'].update({
                    'title': rs.title['month'],
                })

        if 'y' in update:
            jres['year'] = rs.df_to_dygraphs(rs.year_df())
            if jres['year']:
                jres['year']['meta'].update({
                    'showRangeSelector': True,
                    'title': rs.title['year'],
                })

        if rs.lonlat:
            v = rs.point_value()
            plus = jres['metric']['plus'] if v > 0 else ''
            jres['point'] = _('Selected pixel : {}{} {}').format(plus, v, jres['metric']['unit'])

    if benchmark:
        now = time.time()
        print('ys : {}'.format(now - start))
        start = now


    if rs.error:
        jres['error'] = '<ul>' + ''.join(['<li class="err' + e[1] + '">' + e + '</li>' for e in rs.error]) + '</ul>'
    jres['cScen'] = rs.compare_scen

    return JsonResponse(jres)


def text_export(request, period, extension):
    rs = RequestScrapper(request)
    rs.fill_loc_df()
    if period == 'year':
        df = rs.year_df()
    else:
        df = rs.month_df()
    if rs.metric:
        name = rs.metric.shortname + '_'
    else:

proj/templates/proj/about.html
{% extends 'proj/base.html' %}
{% comment %}Translation{% endcomment %}
{% load i18n %}

{% block content %}
<div class="smallpage">
    {% load static %}

    <h2 id="parameters">{% trans 'Parameter list' %}</h2>
    <!--There are currently {{ metrics|length }} parameters in the database.-->
                     {% for c in catmetric %}
    <dl class="description">
                <h3>{{ c }}</h3>
                {% for m in c.metric_set.all %}

        <dt>{{ m }}</dt>
        <dd>{{ m.description }}

        <br><span class="helptext">
                {% if m.formula %}<i>{% trans 'formula' %} :</i> "{{ m.formula }}"
                <i>{% trans 'aggregated by' %}</i> "{{ m.aggregation }}"
                {% else %} <i>{% trans 'yearly data only' %}</i>
                {% endif %}
            </span></dd>
        {% endfor %}
    </dl>
        {% endfor %}
    <h2 id="models">{% trans 'Model list' %}</h2>
    <p>{% blocktrans trimmed %}Not all combinations parameter/scenario/model are available. Many models miss one entire scenario,
        and some miss specific metrics.{% endblocktrans %}</p>
    <dl>
        {% for m in models %}
        <dt style="color:{{ m.color }}">{{ m.name }}</dt>
        <dd>{{ m.description|escape|linebreaks }}
        {% if m.url %}<a class="exturl helptext" href="{{ m.url }}">{{ m.url }}</a>{% endif %}
        {% endfor %}
    </dl>
    {% blocktrans trimmed %}<h2 id="scenarii">Scenarii</h2>
    <p>Representative Concentration Pathways (rcp) are greenhouse gas concentration trajectories adopted by
        the <a href="www.ipcc.ch">IPCC</a> in 2014. They describe possible climate futures, all of which are
        considered possible depending on how much greenhouse gases are emitted in the years to come.
        RCP2.6, RCP4.5, and RCP8.5 are named after a possible range of radiative forcing values in the year 2100
        relative to pre-industrial values (+2.6, +4.5, and +8.5 W/m2, respectively)</p>{% endblocktrans %}

    <p class="helptext"><a href="{% url 'proj:index' %}">{% trans 'back to the main page' %}</a></p>

</div>


{% endblock %}

proj/templates/proj/base.html
<!doctype html>
<html lang="en">
<head>
    {% comment %}Translation{% endcomment %}
    {% load i18n %}
    {% get_current_language as LANGUAGE_CODE %}

    {% load static %}
    {% block scripts %}{% endblock %}
    <link rel="icon" href="{% static 'img/favicon.ico' %}">
    <link rel="stylesheet" href="{% static 'style.css' %}" type="text/css">
    <link rel="stylesheet" href="{% static 'respstyle.css'%}" type="text/css">

    <title>Géoportail Sénégal -- Projections</title>
</head>
<body>
{% block tuto %}
{% endblock %}

<div id="head">
    <h2><a href="{% url 'main' %}">Géoportail Sénégal</a> - Projections
        <img id="wait" src="{% static 'loading.gif' %}" style="height:1em;display:none">
    </h2>
    {% block headinfo %}{% endblock %}
    <div class="links">
        {% block links %}{% endblock %}
{% comment %}
<a href="{% url 'proj:simple' %}">{% trans 'simple' %}</a> &middot;
{% endcomment %}
<a href="{% url 'proj:index' %}">{% trans 'portal' %}</a> &middot;
<a href="{% url 'proj:download' %}">{% trans 'download' %}</a> &middot;
{% if LANGUAGE_CODE == 'fr' %}
<a href="{% url 'proj:lang' 'en' %}?next={{ request.path }}">in english</a> &middot;
{% else %}
<a href="{% url 'proj:lang' 'fr' %}?next={{ request.path }}">en français</a> &middot;
{% endif %}
<a href="{% url 'proj:about' %}">{% trans 'about' %}</a> &middot;
<a href="{% url 'proj:help' %}">{% trans 'manual' %}</a>
</div>

</div>

{% block content %}{% endblock %}

</body>
</html>

proj/templates/proj/formula.html
{% extends 'proj/formula_fr.html' %}

proj/templates/proj/main.html
<!doctype html>
<html lang="en">
<head>
{% comment %}Translation{% endcomment %}
{% load i18n %}
    {% load static %}
    {% block scripts %}{% endblock %}
    <link rel="icon" href="{% static 'img/favicon.ico' %}">
    <link rel="stylesheet" href="{% static 'style.css' %}" type="text/css">
    <link rel="stylesheet" href="{% static 'respstyle.css'%}" type="text/css">

    <meta name="description" content="Visualisation de projections climatiques au Sénégal">
    <meta name="og:type" content="website">
    <meta name="og:description" content="Long-term climate projection in Senegal">
    <meta name="og:title" content="Géoportail Sénégal">
    <meta name="og:image" content="http://{{ request.get_host }}{% static 'geoportail_card.png' %}">
    <meta name="google-site-verification" content="KT_hA7vpUfVntE714Ivzv-2JggBzQIFWM6s_X7gjaRM" />
    <meta name="twitter:card" content="summary">
    <meta name="twitter:title" content="Géoportail Sénégal">
    <meta name="twitter:image" content="http://{{ request.get_host }}{% static 'geoportail_card.png' %}">
    <meta name="twitter:description" content="Long-term climate projection in Senegal">

    <title>Géoportail Sénégal</title>
</head>
<body>
<div id="head" style="height:50px">
    <h2><a href="{% url 'main' %}">Géoportail Sénégal</a></h2>
    {% block headinfo %}{% endblock %}
    <div class="links">
        {% block links %}{% endblock %}
        {% get_current_language as LANGUAGE_CODE %}
        {% if LANGUAGE_CODE == 'fr' %}
        <a href="{% url 'proj:lang' 'en' %}?next={{ request.path }}">in english</a>
        {% else %}
        <a href="{% url 'proj:lang' 'fr' %}?next={{ request.path }}">en français</a>
        {% endif %}
        &middot;
        {% if request.user.is_authenticated %}
        <a href="{% url 'main' %}">home</a> &middot;
        <a href="../admin">django admin</a> &middot;
        <a href="{% url 'stats:comments' %}">comments</a> &middot;
        <a href="{% url 'stats:metric' %}">metrics</a> &middot;
        <a href="{% url 'stats:doc' %}">documentation</a>
        {% else %}
        <a href="{% url 'stats:index' %}">login</a>
        {% endif %}
    </div>

</div>

<div class="smallpage">
    <h2><a href="{% url 'proj:index' %}">{% trans 'Climate projections' %}</a></h2>
    <p style="margin:20px">{% trans 'Long-term climate projections by regions.'%}</p>

    <p style="margin-top:40px">
        <a href="{% url 'stats:commentwrite' %}">{% trans 'You may also make a comment on the site.'%}</a></p>

    {% comment %}
    <h2><a href="{% url 'proj:index' %}">{% trans 'Projections climatiques' %}</a></h2>
    <p style="margin:20px">{% trans 'Projections climatiques à long terme par région.%}</p>

    <p style="margin-top:40px">Vous pouvez également
        <a href="{% url 'stats:commentwrite' %}">faire un commentaire sur le site</a>.</p>
{% endcomment %}

        {% blocktrans trimmed %}<h2>Project description</h2>
<p>This climate service aims at providing intelligible climate projection data in Africa through maps and time
    charts.
    It features several parameters based on temperature, rainfall and agriculture yields, scaled on monthly periods.
</p>

<p>Initial data is <a href="https://esgf-node.llnl.gov/projects/esgf-llnl/">Coupled Model Intercomparison Project
    Phase 5 (CMIP5)</a> global climate models. The version presented here has been
    <a href="https://doi.org/10.5194/esd-9-313-2018">bias-corrected for Africa using CDF-t method</a> as part of the
    <a href="https://www.amma2050.org/">AMMA 2050 project</a>, then re-scaled by month. Crop yield results have
    been obtained by <a href="http://sarra-h.teledetection.fr/SARRAH_Home.html">SARRA-H Ocelet</a>. All this data comes
    as raster data with resolution 0.5°x0.5°, which was cut and weighted to match country and administrative regions.
</p>

<p>This work was supported by a grant from the French Ministry for an Ecological and Solidary Transition as part of
    the Convention on financial support for climate services.</p>{% endblocktrans %}

    <h2>{% trans 'Short presentation'%}</h2>
    <p><video  width=1000 controls>
  <source src="{% static 'presentation.mp4' %}" type="video/mp4">
  Your browser does not support HTML video. Try <a href="{% static 'presentation.mp4' %}">download it</a> instead.
</video></p>


<table class="sponsors5">
    <tr>
        <td><a href="http://cnrs.fr"><img src="{% static 'logo/logo-cnrs.png' %}"></a></td>
        <td><a href="http://ird.fr"><img src="{% static 'logo/logo_ird.png' %}"></a></td>
        <td><a href="http://afd.fr"><img src="{% static 'logo/logo_afd.png' %}"></a></td>
        <td><a href="http://anacim.sn"><img src="{% static 'logo/logo_anacim.jpg' %}"></a></td>
        <td><a href="http://cse.sn"><img src="{% static 'logo/logo_cse.jpg' %}"></a></td>
    </tr>
</table>
<table class="sponsors5">
    <tr>
        <td><a href="https://convention-services-climatiques.lsce.ipsl.fr/"><img
                                                                                 src="{% static 'logo/logo_cosc.png' %}"></a>
        </td>
        <td><a href="http://cse.ipsl.fr"><img src="{% static 'logo/logo_cse2.png' %}"></a></td>
        <td><a href="https://www.ecologique-solidaire.gouv.fr/"><img
                                                                     src="{% static 'logo/logo_mtes.png' %}"></a></td>
        <td><a href="http://www.espace-dev.fr/"><img src="{% static 'logo/logo-espace-dev.jpg' %}"></a></td>
        <td><a href="http://amma2050.org"><img src="{% static 'logo/logo-AMMA_2015.jpg' %}"></a></td>
    </tr>
</table>
    <p class="helptext">This project is powered by <a href="https://www.djangoproject.com/">django</a> and <a
            href="https://www.postgresql.org/">PostgreSQL</a>.
        The map is provided by <a href="https://openlayers.org/">openlayers</a> and graphs by <a
                href="http://dygraphs.com">dygraphs</a>.
        Some <a href="https://feathericons.com/">feather icons</a> are used.</p>

</div>
</body>
</html>

<!--

-->

proj/templates/proj/requestmetric_list.html
{% extends 'proj/base.html' %}

{% block scripts %}
{% load static %}
<script src="{% static 'dygraph.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'dygraph.css' %}" type="text/css">
{% endblock %}

{% block content %}
    <div style="margin-left:50px">
    {% if not ip %}
    <h2>Request history</h2>
    <div id="graphdiv" style="width:80%"></div>
    <p><a style="cursor: pointer"  onclick="toggleCount()">toggle total visibility</a></p>
    {% endif %}
        <h2>Last {{ n }} requests / {{ total }} {% if ip %} from {{ ip }} [<a href="{% url 'proj:metric' %}">X</a>]{% endif %}</h2>
        {% if ip %}
        <p><a href="{% url 'proj:metric_by_ip' ip %}?n=100">100</a> -
        <a href="{% url 'proj:metric_by_ip' ip %}?n=200">200</a> -
        <a href="{% url 'proj:metric_by_ip' ip %}?n=500">500</a> -
        <a href="{% url 'proj:metric_by_ip' ip %}?n=1000">1000</a></p>
        {% else %}
        <p><a href="{% url 'proj:metric' %}?n=100">100</a> -
        <a href="{% url 'proj:metric' %}?n=200">200</a> -
        <a href="{% url 'proj:metric' %}?n=500">500</a> -
        <a href="{% url 'proj:metric' %}?n=1000">1000</a></p>
        {% endif %}
    <ul>
    {% for rm in requestmetric_list %}
        <li>
            <a style="color:blue" href="{% url 'proj:metric_by_ip' rm.ip %}">{{rm.ip}}</a> on <span style="color:red">{{rm.date}}</span>
            <span style="color:gray">({{rm.nav}})</span>
            <br><b><a href="{% url 'proj:index' %}?{{rm.url}}">[link]</a></b> {{rm.url_as_list}}
        </li>
    {% endfor %}
    </ul>
    </div>

{% if not ip %}
<script type="text/javascript">
    graph = new Dygraph(document.getElementById('graphdiv'),
        "{% url 'proj:metric_csv' %}"
    );
    function toggleCount(){
        var v = graph.visibility()[ 0 ];
        graph.setVisibility(0, !v);
    }
</script>
{% endif %}
{% endblock %}